require '_h2ph_pre.ph';

unless(defined(&__ASM_SYSTEM_H)) {
    eval 'sub __ASM_SYSTEM_H () {1;}' unless defined(&__ASM_SYSTEM_H);
    require 'linux/config.ph';
    if(defined(&__KERNEL__)) {
	require 'asm/lowcore.ph';
    }
    require 'linux/kernel.ph';
    eval 'sub prepare_to_switch () {
        eval q( &do { }  &while(0));
    }' unless defined(&prepare_to_switch);
    eval 'sub switch_to {
        local($prev,$next,$last) = @_;
	    eval q( &do {  &if ($prev == $next)  &break;  &save_fp_regs1( ($prev->{thread}->{fp_regs}));  &restore_fp_regs1( ($next->{thread}->{fp_regs})); $last =  &resume( ($prev->{thread}), ($next->{thread})); }  &while (0));
    }' unless defined(&switch_to);
    eval 'sub nop () {
        eval q( &__asm__  &__volatile__ (\\"nop\\"));
    }' unless defined(&nop);
    eval 'sub xchg {
        local($ptr,$x) = @_;
	    eval q((( &__typeof__(*)) &__xchg(($x),($ptr),$sizeof{($ptr)})));
    }' unless defined(&xchg);
    eval 'sub eieio () {
        eval q( &__asm__  &__volatile__ (\\"BCR 15,0\\"));
    }' unless defined(&eieio);
    eval 'sub SYNC_OTHER_CORES {
        local($x) = @_;
	    eval q( &eieio());
    }' unless defined(&SYNC_OTHER_CORES);
    eval 'sub mb () {
        eval q( &eieio());
    }' unless defined(&mb);
    eval 'sub rmb () {
        eval q( &eieio());
    }' unless defined(&rmb);
    eval 'sub wmb () {
        eval q( &eieio());
    }' unless defined(&wmb);
    eval 'sub smp_mb () {
        eval q( &mb());
    }' unless defined(&smp_mb);
    eval 'sub smp_rmb () {
        eval q( &rmb());
    }' unless defined(&smp_rmb);
    eval 'sub smp_wmb () {
        eval q( &wmb());
    }' unless defined(&smp_wmb);
    eval 'sub smp_mb__before_clear_bit () {
        eval q( &smp_mb());
    }' unless defined(&smp_mb__before_clear_bit);
    eval 'sub smp_mb__after_clear_bit () {
        eval q( &smp_mb());
    }' unless defined(&smp_mb__after_clear_bit);
    eval 'sub set_mb {
        local($var, $value) = @_;
	    eval q( &do { $var = $value;  &mb(); }  &while (0));
    }' unless defined(&set_mb);
    eval 'sub set_wmb {
        local($var, $value) = @_;
	    eval q( &do { $var = $value;  &wmb(); }  &while (0));
    }' unless defined(&set_wmb);
    eval 'sub __sti () {
        eval q(({  &__u8  &dummy;  &__asm__  &__volatile__ ( \\"stosm %0,0x03\\" : \\"=m\\" ( &dummy) : : \\"memory\\"); }));
    }' unless defined(&__sti);
    eval 'sub __cli () {
        eval q(({  &__u32  &flags;  &__asm__  &__volatile__ ( \\"stnsm %0,0xFC\\" : \\"=m\\" ( &flags) : : \\"memory\\");  &flags; }));
    }' unless defined(&__cli);
    eval 'sub __save_flags {
        local($x) = @_;
	    eval q( &__asm__  &__volatile__(\\"stosm %0,0\\" : \\"=m\\" ($x) : : \\"memory\\"));
    }' unless defined(&__save_flags);
    eval 'sub __restore_flags {
        local($x) = @_;
	    eval q( &__asm__  &__volatile__(\\"ssm   %0\\" : : \\"m\\" ($x) : \\"memory\\"));
    }' unless defined(&__restore_flags);
    eval 'sub __load_psw {
        local($psw) = @_;
	    eval q( &__asm__  &__volatile__(\\"lpsw %0\\" : : \\"m\\" ($psw) : \\"cc\\" ););
    }' unless defined(&__load_psw);
    eval 'sub __ctl_load {
        local($array, $low, $high) = @_;
	    eval q(({  &__asm__  &__volatile__ ( \\"   la    1,%0\\\\n\\" \\"   bras  2,0f\\\\n\\" \\"   lctl  0,0,0(1)\\\\n\\" \\"0: ex    %1,0(2)\\" : : \\"m\\" ($array), \\"a\\" ((($low)<<4)+($high)) : \\"1\\", \\"2\\" ); }));
    }' unless defined(&__ctl_load);
    eval 'sub __ctl_store {
        local($array, $low, $high) = @_;
	    eval q(({  &__asm__  &__volatile__ ( \\"   la    1,%0\\\\n\\" \\"   bras  2,0f\\\\n\\" \\"   stctl 0,0,0(1)\\\\n\\" \\"0: ex    %1,0(2)\\" : \\"=m\\" ($array) : \\"a\\" ((($low)<<4)+($high)): \\"1\\", \\"2\\" ); }));
    }' unless defined(&__ctl_store);
    eval 'sub __ctl_set_bit {
        local($cr, $bit) = @_;
	    eval q(({  &__u8  $dummy[16];  &__asm__  &__volatile__ ( \\"    la    1,%0\\\\n\\" \\"    ahi   1,7\\\\n\\" \\"    srl   1,3\\\\n\\" \\"    sll   1,3\\\\n\\" \\"    bras  2,0f\\\\n\\" \\"    stctl 0,0,0(1)\\\\n\\" \\"    lctl  0,0,0(1)\\\\n\\" \\"0:  ex    %1,0(2)\\\\n\\" \\"    l     0,0(1)\\\\n\\" \\"    or    0,%2\\\\n\\" \\"    st    0,0(1)\\\\n\\" \\"1:  ex    %1,4(2)\\" : \\"=m\\" ( &dummy) : \\"a\\" ($cr*17), \\"a\\" (1<<($bit)) : \\"cc\\", \\"0\\", \\"1\\", \\"2\\"); }));
    }' unless defined(&__ctl_set_bit);
    eval 'sub __ctl_clear_bit {
        local($cr, $bit) = @_;
	    eval q(({  &__u8  $dummy[16];  &__asm__  &__volatile__ ( \\"    la    1,%0\\\\n\\" \\"    ahi   1,7\\\\n\\" \\"    srl   1,3\\\\n\\" \\"    sll   1,3\\\\n\\" \\"    bras  2,0f\\\\n\\" \\"    stctl 0,0,0(1)\\\\n\\" \\"    lctl  0,0,0(1)\\\\n\\" \\"0:  ex    %1,0(2)\\\\n\\" \\"    l     0,0(1)\\\\n\\" \\"    nr    0,%2\\\\n\\" \\"    st    0,0(1)\\\\n\\" \\"1:  ex    %1,4(2)\\" : \\"=m\\" ( &dummy) : \\"a\\" ($cr*17), \\"a\\" (~(1<<($bit))) : \\"cc\\", \\"0\\", \\"1\\", \\"2\\"); }));
    }' unless defined(&__ctl_clear_bit);
    eval 'sub local_irq_save {
        local($x) = @_;
	    eval q((($x) =  &__cli()));
    }' unless defined(&local_irq_save);
    eval 'sub local_irq_restore {
        local($x) = @_;
	    eval q( &__restore_flags($x));
    }' unless defined(&local_irq_restore);
    eval 'sub local_irq_disable () {
        eval q( &__cli());
    }' unless defined(&local_irq_disable);
    eval 'sub local_irq_enable () {
        eval q( &__sti());
    }' unless defined(&local_irq_enable);
    if(defined(&CONFIG_SMP)) {
	eval 'sub cli () {
	    eval q( &__global_cli());
	}' unless defined(&cli);
	eval 'sub sti () {
	    eval q( &__global_sti());
	}' unless defined(&sti);
	eval 'sub save_flags {
	    local($x) = @_;
    	    eval q((($x)= &__global_save_flags()));
	}' unless defined(&save_flags);
	eval 'sub restore_flags {
	    local($x) = @_;
    	    eval q( &__global_restore_flags($x));
	}' unless defined(&restore_flags);
	eval 'sub ctl_set_bit {
	    local($cr, $bit) = @_;
    	    eval q( &smp_ctl_set_bit($cr, $bit));
	}' unless defined(&ctl_set_bit);
	eval 'sub ctl_clear_bit {
	    local($cr, $bit) = @_;
    	    eval q( &smp_ctl_clear_bit($cr, $bit));
	}' unless defined(&ctl_clear_bit);
    } else {
	eval 'sub cli () {
	    eval q( &__cli());
	}' unless defined(&cli);
	eval 'sub sti () {
	    eval q( &__sti());
	}' unless defined(&sti);
	eval 'sub save_flags {
	    local($x) = @_;
    	    eval q( &__save_flags($x));
	}' unless defined(&save_flags);
	eval 'sub restore_flags {
	    local($x) = @_;
    	    eval q( &__restore_flags($x));
	}' unless defined(&restore_flags);
	eval 'sub ctl_set_bit {
	    local($cr, $bit) = @_;
    	    eval q( &__ctl_set_bit($cr, $bit));
	}' unless defined(&ctl_set_bit);
	eval 'sub ctl_clear_bit {
	    local($cr, $bit) = @_;
    	    eval q( &__ctl_clear_bit($cr, $bit));
	}' unless defined(&ctl_clear_bit);
    }
    if(defined(&__KERNEL__)) {
    }
}
1;
